# This an autogenerated file
# 
# Generated with TraceConfiguration
from typing import Dict,Sequence,List
from dmt.entity import Entity
from dmt.blueprint import Blueprint
from .blueprints.traceconfiguration import TraceConfigurationBlueprint
from sima.post.linestyle import LineStyle
from sima.post.pathspecification import PathSpecification
from sima.post.pointstyle import PointStyle
from sima.sima.scriptablevalue import ScriptableValue
from sima.sima.simacolor import SIMAColor

class TraceConfiguration(PathSpecification):
    """
    Keyword arguments
    -----------------
    name : str
         (default "")
    description : str
         (default "")
    _id : str
         (default "")
    scriptableValues : List[ScriptableValue]
    path : str
         (default "")
    label : str
         (default "")
    color : SIMAColor
    lineStyle : LineStyle
    lineWidth : int
         (default 1)
    pointStyle : PointStyle
    showStatistics : bool
         (default True)
    pointSize : int
         (default 1)
    specifyPath : bool
         (default False)
    """

    def __init__(self , name:str="", description:str="", _id:str="", path:str="", label:str="", lineStyle:LineStyle=LineStyle.SOLID, lineWidth:int=1, pointStyle:PointStyle=PointStyle.NONE, showStatistics:bool=True, pointSize:int=1, specifyPath:bool=False, **kwargs):
        super().__init__(**kwargs)
        self.__name = name
        self.__description = description
        self.___id = _id
        self.__scriptableValues = list()
        self.__path = path
        self.__label = label
        self.__color = SIMAColor()
        self.__lineStyle = lineStyle
        self.__lineWidth = lineWidth
        self.__pointStyle = pointStyle
        self.__showStatistics = showStatistics
        self.__pointSize = pointSize
        self.__specifyPath = specifyPath
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return TraceConfigurationBlueprint()


    @property
    def name(self) -> str:
        """"""
        return self.__name

    @name.setter
    def name(self, value: str):
        """Set name"""
        self.__name = str(value)

    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = str(value)

    @property
    def _id(self) -> str:
        """"""
        return self.___id

    @_id.setter
    def _id(self, value: str):
        """Set _id"""
        self.___id = str(value)

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def path(self) -> str:
        """"""
        return self.__path

    @path.setter
    def path(self, value: str):
        """Set path"""
        self.__path = str(value)

    @property
    def label(self) -> str:
        """"""
        return self.__label

    @label.setter
    def label(self, value: str):
        """Set label"""
        self.__label = str(value)

    @property
    def color(self) -> SIMAColor:
        """"""
        return self.__color

    @color.setter
    def color(self, value: SIMAColor):
        """Set color"""
        self.__color = value

    @property
    def lineStyle(self) -> LineStyle:
        """"""
        return self.__lineStyle

    @lineStyle.setter
    def lineStyle(self, value: LineStyle):
        """Set lineStyle"""
        self.__lineStyle = value

    @property
    def lineWidth(self) -> int:
        """"""
        return self.__lineWidth

    @lineWidth.setter
    def lineWidth(self, value: int):
        """Set lineWidth"""
        self.__lineWidth = int(value)

    @property
    def pointStyle(self) -> PointStyle:
        """"""
        return self.__pointStyle

    @pointStyle.setter
    def pointStyle(self, value: PointStyle):
        """Set pointStyle"""
        self.__pointStyle = value

    @property
    def showStatistics(self) -> bool:
        """"""
        return self.__showStatistics

    @showStatistics.setter
    def showStatistics(self, value: bool):
        """Set showStatistics"""
        self.__showStatistics = bool(value)

    @property
    def pointSize(self) -> int:
        """"""
        return self.__pointSize

    @pointSize.setter
    def pointSize(self, value: int):
        """Set pointSize"""
        self.__pointSize = int(value)

    @property
    def specifyPath(self) -> bool:
        """"""
        return self.__specifyPath

    @specifyPath.setter
    def specifyPath(self, value: bool):
        """Set specifyPath"""
        self.__specifyPath = bool(value)
