# This an autogenerated file
# 
# Generated with NotchFilter
from typing import Dict,Sequence,List
from dmt.entity import Entity
from dmt.blueprint import Blueprint
from .blueprints.notchfilter import NotchFilterBlueprint
from sima.sima.scriptablevalue import ScriptableValue
from sima.simo.estimator import Estimator

class NotchFilter(Estimator):
    """
    Keyword arguments
    -----------------
    name : str
         (default "")
    description : str
         (default "")
    _id : str
         (default "")
    scriptableValues : List[ScriptableValue]
    centerPeriod : float
         Center period of wave filter(default 10.0)
    strength : float
         Strength of wave filter, between 0 and 1(default 1.0)
    """

    def __init__(self , name:str="", description:str="", _id:str="", centerPeriod:float=10.0, strength:float=1.0, **kwargs):
        super().__init__(**kwargs)
        self.__name = name
        self.__description = description
        self.___id = _id
        self.__scriptableValues = list()
        self.__centerPeriod = centerPeriod
        self.__strength = strength
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return NotchFilterBlueprint()


    @property
    def name(self) -> str:
        """"""
        return self.__name

    @name.setter
    def name(self, value: str):
        """Set name"""
        self.__name = str(value)

    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = str(value)

    @property
    def _id(self) -> str:
        """"""
        return self.___id

    @_id.setter
    def _id(self, value: str):
        """Set _id"""
        self.___id = str(value)

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def centerPeriod(self) -> float:
        """Center period of wave filter"""
        return self.__centerPeriod

    @centerPeriod.setter
    def centerPeriod(self, value: float):
        """Set centerPeriod"""
        self.__centerPeriod = float(value)

    @property
    def strength(self) -> float:
        """Strength of wave filter, between 0 and 1"""
        return self.__strength

    @strength.setter
    def strength(self, value: float):
        """Set strength"""
        self.__strength = float(value)
